/// <reference types="node" />
import { Observable } from 'rxjs';
import { EventEmitter } from 'events';
import { DeviceScanner, DeviceScannerOptions } from '@iotize/tap/scanner/api';
import { Peripheral } from '@abandonware/noble';
import { noble } from './types';
export declare class NobleBleScanner implements DeviceScanner<Peripheral> {
    static DEFAULT_TIMEOUT_GET_DEVICE: number;
    static TIMEOUT_WAIT_FOR_POWER_ON: number;
    _noble: noble;
    emitter: EventEmitter;
    private _discoverCallback?;
    private _timeoutHandler?;
    private _results;
    private _singleResults;
    private _scanning;
    private _items;
    get scanning(): Observable<boolean>;
    get isScanning(): boolean;
    get results(): Observable<Peripheral[]>;
    get peripherals(): Peripheral[];
    constructor(nobleInstance: noble);
    /**
     * Start device scan
     * @param option
     */
    start(option?: DeviceScannerOptions): Promise<void>;
    _onItemDiscovered(peripheral: Peripheral): void;
    stop(): Promise<void>;
    getDeviceByAddress(address: string, options?: {
        timeout?: number;
    }): Promise<Peripheral>;
    on(event: string, fct: any): this;
}
