import { NobleState, NobleType } from '..';
import { noble } from './types';
export declare const NOBLE_UWP_PACKAGE = "@iotize/noble-uwp";
export declare const NOBLE_PACKAGE = "@abandonware/noble";
export declare class NobleHelper {
    static MINIMAL_WINDOWS_BUILD_VERSION: string;
    static _VALID_LIST: string[];
    static isAvailable(_noble: NobleType): boolean;
    static waitForNobleState(state: string | NobleState, timeoutMs: number, _noble: NobleType): Promise<string>;
    /**
     * Return true if noble UWP is supported
     * TODO also check windows SDK build
     */
    static isNobleUwpSupported(): boolean;
    static isNobleUwp(noble: any): boolean;
    /**
     * TODO add typing
     * @param useUwpIfAvailable false if you don't want to try to use noble-uwp
     */
    static getNoble(useUwpIfAvailable?: boolean): Promise<noble>;
    static getNobleSync(useUwpIfAvailable?: boolean): noble;
    static isPackageInstalled(packageName: string): boolean;
}
