/// <reference types="node" />
import { Peripheral } from '@abandonware/noble';
import * as events from 'events';
export interface noble {
    startScanning(): void;
    startScanning(serviceUUIDs: string[], callback?: (error?: Error) => void): void;
    startScanning(serviceUUIDs: string[], allowDuplicates: boolean, callback?: (error?: Error) => void): void;
    stopScanning(callback?: () => void): void;
    on(event: 'stateChange', listener: (state: string) => void): events.EventEmitter;
    on(event: 'scanStart', listener: () => void): events.EventEmitter;
    on(event: 'scanStop', listener: () => void): events.EventEmitter;
    on(event: 'discover', listener: (peripheral: Peripheral) => void): events.EventEmitter;
    on(event: string, listener: Function): events.EventEmitter;
    removeListener(event: 'stateChange', listener: (state: string) => void): events.EventEmitter;
    removeListener(event: 'scanStart', listener: () => void): events.EventEmitter;
    removeListener(event: 'scanStop', listener: () => void): events.EventEmitter;
    removeListener(event: 'discover', listener: (peripheral: Peripheral) => void): events.EventEmitter;
    removeListener(event: string, listener: Function): events.EventEmitter;
    state: string;
}
export { Advertisement, Service, Characteristic, Descriptor, Peripheral, } from '@abandonware/noble';
